//+------------------------------------------------------------------+
//|                                           T3_Momentum_Burst.mq4  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  LimeGreen
#property indicator_width1  2
#property indicator_width2  2
#property indicator_level1  0

//
//
//
//
//

extern string TimeFrame1      = "Current time frame";
extern int    Mom_Period1     = 1;
extern int    T3_period1      = 28;
extern double T3_hot1         = 0.618;
extern int    T3_calculation1 = 2;
extern bool   Interpolate1    = true;
extern double Multiplier1     = 1.0;

extern string TimeFrame2      = "H1";
extern int    Mom_Period2     = 1;
extern int    T3_period2      = 28;
extern double T3_hot2         = 0.618;
extern int    T3_calculation2 = 2;
extern bool   Interpolate2    = true;
extern double Multiplier2     = 1.0;

extern int    NormalizePeriod = 0;

extern string IndicatorFileName = "T3_Momentum Burst + mtf nmc";

//
//
//
//
//

double MapBuffer1[];
double MapBuffer2[];
double MapBuffer3[];
double MapBuffer4[];

int    timeFrame1;
int    timeFrame2;
string targetTimeFrame1;
string targetTimeFrame2;
string fileNameForBars;
bool   returningBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,MapBuffer1);
   SetIndexBuffer(1,MapBuffer2);
   SetIndexBuffer(2,MapBuffer3);
   SetIndexBuffer(3,MapBuffer4);

   timeFrame1 = stringToTimeFrame(TimeFrame1);
   timeFrame2 = stringToTimeFrame(TimeFrame2);
   targetTimeFrame1 = timeFrameToString(timeFrame1);
   targetTimeFrame2 = timeFrameToString(timeFrame2);

      fileNameForBars = WindowExpertName();
      returningBars   = (TimeFrame1=="returnBars"); if (returningBars) return(0);

   //
   //
   //
   //
   //
   
   IndicatorShortName("T3_Momentum_Burst "+targetTimeFrame1+" - "+targetTimeFrame2+" ("+T3_period1+","+T3_period1+")");
   IndicatorDigits(Digits);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returningBars) { MapBuffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame1,fileNameForBars,"returnBars",0,0)*timeFrame1/Period()));
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame2,fileNameForBars,"returnBars",0,0)*timeFrame2/Period()));
   for (i=limit;i>=0;i--)
   {
      MapBuffer3[i] = Multiplier1*iCustom(NULL,0,IndicatorFileName,targetTimeFrame1,Mom_Period1,T3_period1,T3_hot1,T3_calculation1,Interpolate1,0,i);
      MapBuffer4[i] = Multiplier2*iCustom(NULL,0,IndicatorFileName,targetTimeFrame2,Mom_Period2,T3_period2,T3_hot2,T3_calculation2,Interpolate2,0,i);
      
      //
      //
      //
      //
      //
      
      if (NormalizePeriod>1)
      {
         double hi = MapBuffer3[ArrayMaximum(MapBuffer3,NormalizePeriod,i)];
         double lo = MapBuffer3[ArrayMinimum(MapBuffer3,NormalizePeriod,i)];
         if (hi!=lo)
               MapBuffer1[i] = (MapBuffer3[i]-lo)/(hi-lo);
         else  MapBuffer1[i] = 0;

         //
         //
         //
         //
         //
         
         hi = MapBuffer4[ArrayMaximum(MapBuffer4,NormalizePeriod,i)];
         lo = MapBuffer4[ArrayMinimum(MapBuffer4,NormalizePeriod,i)];
         if (hi!=lo)
               MapBuffer2[i] = (MapBuffer4[i]-lo)/(hi-lo);
         else  MapBuffer2[i] = 0;
      }
      else
      {
         MapBuffer1[i] = MapBuffer3[i];
         MapBuffer2[i] = MapBuffer4[i];
      }
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}